#ifndef _SOCK_UTIL_H_
#define _SOCK_UTIL_H_

#include <windows.h>
#include <winsock.h>
#include <stdio.h>

// Bind options
#define DEFAULT_PORT 1
#define FIXED_PORT   2
#define LOCAL_ADDR   3
#define REMOTE_ADDR  4
#define REMOTE_PORT  5

#define CLIENT_QUEUE_SIZE 5

int WinSockInitialize();

u_long  GetLocalHostAddress();
u_long  GetHostAddress(LPSTR pszHostName);
u_short GetPortForService(LPSTR pszServiceName, LPSTR pszProtocol);

SOCKET CreateSocket (int type);
int BindSocketToAddr (int iBindType,
                      SOCKET soc,
                      LPSTR pszServiceName,
                      LPSTR pszProtocolName,
                      int iPortNumber,
                      BOOL fClient);
int ConnectToServer (int iBindType, 
                     SOCKET soc,
                     LPSTR szHostName, 
                     LPSTR szServiceName,
                     LPSTR szProtocol,
                     int iPortNumber);

void atoh (char *dest, char *src, int size);

#endif // _SOCK_UTIL_H_
